package com.malk.xinwei.controller;

import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilServlet;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见 CatchException
 */
@Slf4j
@RestController
@RequestMapping("/chuoqi")
@EnableAsync
public class ChuoQiController {

    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDService ddService;

    /**** 绰琪服务 ****/

    @PostMapping("validate")
    public McR validateLeave(@RequestBody Map<String, String> param) {
        McException.assertParamException_Null(UtilServlet.isNull(param, "processInstanceId", "userId"));
        Map instance = ddClient.queryProcessInstanceId(param.get("processInstanceId"));
        List<Map> compList = (List<Map>) instance.get("form_component_values");
        String type = String.valueOf(compList.stream().filter(item -> item.get("component_type").equals("DDHolidayField")).findAny().get().get("value"));
        String dept = String.valueOf(instance.get("originator_dept_name"));
        log.info("余额校验请求入参: {}, {}, {}", param, type, dept);
        // 调休的小时数只能是4的倍数
        if (type.contains("调休") && !dept.contains("河源")) {
            float budget = Float.valueOf(String.valueOf(JSON.parseArray(type).get(2)));
            if (budget % 4 != 0) {
                log.info("撤销请假, {}", instance);
                ddService.terminateRunningApprove_async(param.get("processInstanceId"), true, "调休必须以4小时为最小单位", "", param.get("userId"));
            }
        }
        return McR.success();
    }
}
