package com.malk.xinwei.controller;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilMap;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见 CatchException
 */
@Slf4j
@RestController
@RequestMapping("/chuoqi")
@EnableAsync
public class LiChenController {

    /**** 力辰服务 ****/

    @Autowired
    private YDClient ydClient;

    /**
     * 查询实例详情: 力辰查询实例详情接口
     */
    @GetMapping("lc/form/{formInstId}")
    McR getInstanceById(@PathVariable String formInstId) {

        YDParam ydParam = YDParam.builder()
                .appType("APP_BV3K6QNMINKYEDHQNI4N")
                .systemToken("CH766981WHM8OEVBEAKCY7MYB9SV3ORPLIQELS5")
                .formInstId(formInstId)
                .build();
        return McR.success(ydClient.operateData(YDConf.API_FORM_DETAIL, ydParam));
    }

    /**
     * 写入往来单位
     */
    @SneakyThrows
    @PostMapping("lc/form/wldx")
    McR updateWangLaiDanWei(@RequestBody Map data) {

        log.info("写入往来单位, {}", data);

        List<Map> list = (List<Map>) data.get("data");
        for (Map record : list) {
            Map searchMap = UtilMap.map("textField_lgpz4fmf", record.get("FNumber"));
            YDParam ydParam = YDParam.builder()
                    .appType("APP_BV3K6QNMINKYEDHQNI4N")
                    .systemToken("CH766981WHM8OEVBEAKCY7MYB9SV3ORPLIQELS5")
                    .formUuid("FORM-A8666NA1404AITYX7V2NI9VHO2TK3TYOVYPGL0")
                    .searchFieldJson(JSON.toJSONString(searchMap))
                    .build();
            Map rsp = ydClient.queryData(YDConf.API_FORM_QUERY_ID, ydParam);
            if (ObjectUtil.isNotNull(rsp) && Integer.valueOf(String.valueOf((rsp.get("totalCount")))) == 0) {
                ydParam.formDataJson = JSON.toJSONString(UtilMap.map("textField_lgpz6rn1, textField_lgpz4fmf", record.get("FName"), record.get("FNumber"))); // 往来名称：textField_lgpz6rn1; 往来编码：textField_lgpz4fmf
                ydClient.operateDataByConcurrence(YDConf.API_FORM_CREATE, ydParam);
            }
            Thread.sleep(500);
        }
        return McR.success();
    }

    /**
     * 写入付款申请
     */
    @SneakyThrows
    @PostMapping("lc/form/fksq")
    McR updateFuKuanShenQing(@RequestBody Map data) {

        log.info("写入付款申请, {}", data);

        List<Map> list = (List<Map>) data.get("data");
        for (Map record : list) {
            String billNo = String.valueOf(record.get("FBillNo"));
            if (billNo.contains("FKSQ")) {
                Map searchMap = UtilMap.map("textField_lgov75ms", billNo);
                YDParam ydParam = YDParam.builder()
                        .appType("APP_BV3K6QNMINKYEDHQNI4N")
                        .systemToken("CH766981WHM8OEVBEAKCY7MYB9SV3ORPLIQELS5")
                        .formUuid("FORM-4V966QC142J8WYDD9PO74DD2QOME3ZG0MIQELK1")
                        .searchFieldJson(JSON.toJSONString(searchMap))
                        .build();
                Map rsp = ydClient.queryData(YDConf.API_FORM_QUERY_ID, ydParam);
                if (ObjectUtil.isNotNull(rsp) && Integer.valueOf(String.valueOf((rsp.get("totalCount")))) == 0) {
                    Map formData = UtilMap.map("textField_lgov75ms, radioField_lguqzv36", billNo, "是");
                    formData.put("textField_lglwgnl7", record.get("FCREATORID"));
                    formData.put("textField_lguqqubv", record.get("FCREATORNAME"));
                    formData.put("", record.get("FPURCHASEORGID"));
                    formData.put("dateField_leqinlqd", record.get("FDATE"));
                    formData.put("", record.get("FBILLTYPEID"));
                    formData.put("selectField_lgpzoio6", record.get("FCONTACTUNITTYPE"));
                    formData.put("selectField_lexydxa5", record.get("FCONTACTUNIT"));
                    formData.put("", record.get("FBUSINESSTYPE"));
                    formData.put("textField_lewk1q3x", record.get("FPAYORGID"));
                    formData.put("", record.get("F_BQB_Combo"));
                    formData.put("radioField_leqinlq7", record.get("F_BQB_FKDQ"));
                    List<Map> details = new ArrayList<>();
                    List<Map> dataTable = (List<Map>) JSON.parse(String.valueOf(record.get("DataTable")));
                    for (Map detail : dataTable) {
                        Map rowTable = UtilMap.map("selectField_lewl78sf", detail.get("FSETTLETYPEID"));
                        rowTable.put("textField_lfw71laq", detail.get("FEACHBANKACCOUNT"));
                        rowTable.put("numberField_leqinlqa", detail.get("FAPPLYAMOUNTFOR"));
                        rowTable.put("dateField_lewl78sh", detail.get("FENDDATE"));
                        rowTable.put("dateField_lewl78sg", detail.get("FEXPECTPAYDATE"));
                        rowTable.put("textField_lfw71lar", detail.get("FEACHCCOUNTNAME"));
                        rowTable.put("textField_lfw71las", detail.get("FEACHBANKNAME"));
                        rowTable.put("textField_leqinlq9", detail.get("FCOSTID"));
                        details.add(rowTable);
                    }
                    formData.put("tableField_leqinlq8", details);
                    ydParam.formDataJson = JSON.toJSONString(formData);
                    ydParam.setProcessCode("TPROC--4V966QC142J8WYDD9PO74DD2QOME30H0MIQELL1");
                    ydClient.operateDataByConcurrence(YDConf.API_PROCESS_CREATE, ydParam);
                }
                /**
                 *   创建人编码：FCREATORID						宜搭：textField_lglwgnl7
                 *   创建人姓名：FCREATORNAME					    宜搭：textField_lguqqubv
                 * 	 采购组织：FPURCHASEORGID 				    宜搭：
                 * 	 申请日期：FDATE							    宜搭：dateField_leqinlqd
                 * 	 单据类型：FBILLTYPEID						宜搭：
                 * 	 往来单位类型：FCONTACTUNITTYPE  		        宜搭：selectField_lgpzoio6
                 * 	 往来单位：FCONTACTUNIT  				        宜搭：selectField_lexydxa5
                 * 	 业务类型：FBUSINESSTYPE 					    宜搭：
                 * 	 付款组织：FPAYORGID  					    宜搭：textField_lewk1q3x
                 * 	 付款类型：F_BQB_Combo 					    宜搭：
                 * 	 付款地区：F_BQB_FKDQ  (必填项)			    宜搭：radioField_leqinlq7
                 *   付款申请单明细：DataTable
                 * 	    结算方式：FSETTLETYPEID 					宜搭：selectField_lewl78sf
                 * 	    对方银行账号：FEACHBANKACCOUNT 		    宜搭：textField_lfw71laq
                 * 	    申请付款金额：FAPPLYAMOUNTFOR 			    宜搭：numberField_leqinlqa
                 * 	    到期日：FENDDATE  						宜搭：dateField_lewl78sh
                 * 	    期望付款日期：FEXPECTPAYDATE  			    宜搭：dateField_lewl78sg
                 * 	    对方账户名称：FEACHCCOUNTNAME 	        	宜搭：textField_lfw71lar
                 * 	    对方开户行：FEACHBANKNAME 				宜搭：textField_lfw71las
                 * 	    费用项目：FCOSTID 						宜搭：textField_leqinlq9
                 */
                Thread.sleep(500);
            }
        }
        return McR.success();
    }
}
