package com.malk.server.dingtalk;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.util.List;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class DDApproveDTO {

    // 审批流的唯一码
    @NotNull
    private String processCode;

    // 审批流发起人的userId
    private String originatorUserId;

    // 发起人所在部门
    private Long deptId;

    // 审批流表单参数
    private List<FormComponentValue> formValues;

    // 审批单页面信息
    @Data
    public static class FormComponentValue {

        private String name;

        private String value;

        /**
         * 每一个组件都是集合, table为集合嵌套集合
         */
        private List<List<FormComponentValue>> details;

        /**
         * 主表组件构造器
         */
        public FormComponentValue(String name, String value) {
            this.name = name;
            this.value = value;
        }

        /**
         * 明细组件构造器
         */
        public FormComponentValue(String name, List<List<FormComponentValue>> details) {
            this.name = name;
            this.details = details;
        }
    }
}
