package com.malk.server.dingtalk;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * 读取配置文件参考FilePah
 */
@Data
@Component
@ConfigurationProperties(prefix = "dingtalk")
public class DDConf {

    private String agentId;

    private String appKey;

    private String appSecret;

    private String corpId;

    private String aesKey;

    private String token;

    // 操作人, 需要为OA后台管理员
    private String operator;

    /**
     * 钉钉一级部门: 1
     */
    public static final Number TOP_DEPARTMENT = 1;

    /**
     * 钉钉回调响应
     */
    public static final String CALLBACK_RESPONSE = "success";

    /**
     * 验证注册地址, 通过开发平台配置触发
     */
    public static final String CALLBACK_CHECK = "check_url";

    /**
     * 审批任务回调
     */
    public static final String BPMS_TASK_CHANGE = "bpms_task_change";

    /**
     * 审批实例回调
     */
    public static final String BPMS_INSTANCE_CHANGE = "bpms_instance_change";
}
