package com.malk.server.dingtalk;

import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor
public class DDR<T> extends VenR {

    // 请求失败
    private String errcode;

    private String errmsg;

    private T result;

    /**
     * token 接口
     */
    private String accessToken;
    private int expiresIn;

    /**
     * 审批实例ID
     */
    private String processInstanceId;

    /**
     * 审批实例详情
     */
    private Map processInstance;

    /**
     * 回调失败事件
     */
    private List<Map> failedList;

    /**
     * 考勤打卡数据
     */
    private List<Map> recordresult;

    // 成功状态标记
    private final static String SUC_CODE = "0";

    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        McException.assertException(!errcode.equals(SUC_CODE), errcode, errmsg, "DD");
    }
}
