package com.malk.server.ekuaibao;

import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor


public class EKBR extends VenR {

    private String errcode;

    private String errmsg;

    /**
     * token 接口
     */
    private String token;

    /**
     * 采购订单接口 - 集合
     */
    private List<Map> purchaseorderlist;

    /**
     * 采购订单接口 - 总量
     */
    private String row_count;

    /**
     * 单张采购订单详情
     */
    private Map purchaseorder;

    /**
     * 平台交易号: 幂等[创建u8单据, 同一个交易号保证 ERP 中的资源不会重复被创建]
     */
    private Map trade;

    // 成功状态标记
    private final static String SUC_CODE = "0";

    // 查询列表为空
    private final static String EMP_LIST = "20002";

    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        McException.assertException(!errcode.equals(SUC_CODE) && !errcode.equals(EMP_LIST), errcode, errmsg, "U8");
    }
}

