package com.malk.server.feishu;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.util.List;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class FSApproveDTO {

    // 审批定义 code
    @NotNull
    private String approval_code;

    // 发起审批用户
    private String user_id;

    // 发起审批用户部门id，如果用户只属于一个部门，可以不填。如果属于多个部门，默认会选择部门列表第一个部门
    //private String department_id;

    // 控件值: json数组
    private String form;

    // 审批单页面信息
    @Data
    public static class FormComponent {

        private String id;

        private String type;

        private Object value;

        /**
         * 每一个组件都是集合, table为集合嵌套集合
         */
        private List<List<FormComponent>> details;

        /**
         * 主表组件构造器
         * -
         * 补充说明: 联系人, 部门, 附件, 关联审批单 为 List<String> 类型, 使用 Object 为向下兼容. 声明类型或调用入参做类型转化, 不要识别到子表单创建了
         */
        public FormComponent(String id, String type, Object value) {
            this.id = id;
            this.type = type;
            this.value = value;
        }

        /**
         * 明细组件构造器
         */
        public FormComponent(String id, String type, List<List<FormComponent>> details) {
            this.id = id;
            this.type = type;
            this.details = details;
        }
    }
}
