package com.malk.server.feishu;

import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor
public class FSR<T> extends VenR {

    private String code;

    private String msg;

    /**
     * token 接口
     */
    private String token;
    private int expire;
    private String app_access_token;
    private String tenant_access_token;

    /**
     * 接口返回数据
     */
    private T data;

    // 成功状态标记
    private final static String SUC_CODE = "0";

    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        McException.assertException(!code.equals(SUC_CODE), code, msg, "FS");
    }
}
