package com.malk.server.teambition;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * 读取配置文件参考FilePah
 */
@Data
@Component
@ConfigurationProperties(prefix = "teambition")
public class TBConf {

    private String AppID;

    private String AppSecret;

    private String TenantId;

    private String OperatorId;

    /**
     * 一个分页数量上限 [上限 1000]
     */
    public static final Integer PAGE_SIZE_LIMIT = 1000;

    /**
     * 租户类型: 默认是组织
     */
    public static final String TENANT_TYPE = "organization";

    /**
     * 推送事件验证
     */
    public static final String EVENT_VERIFY_HOOK = "VERIFY_HOOK";

    /**
     * 项目更新事件
     */
    public static final String EVENT_PROJECT_UPDATE = "v3.project.name.update";

    /**
     * 项目创建事件: 会推送两次, 在第二次推送多 { data: { project: { operatorId, url }} } 这两个字段内容 [接口创建项目也会推送]
     */
    public static final String EVENT_PROJECT_CREAT = "project.create";

    /**
     * 任务创建回调
     */
    public static final String EVENT_TASK_CREATE = "task.create";

    /**
     * 任务更新回调
     */
    public static final String EVENT_TASK_UPDATE = "task.update";

}
