package com.malk.service.aliwork;

import com.malk.server.aliwork.YDParam;

import java.util.Map;
import java.util.concurrent.Future;

/**
 * 函数式编程 & 异步并发实现：详见 YDService
 */
public interface YDClient {

    @FunctionalInterface
    interface QueryLambda {
        void dataMap(Map data);
    }

    @FunctionalInterface
    interface OperateLambda {
        void result(Object result);
    }

    // 加载秘钥
    void loadSystemToken(YDParam param);

    // 查询数据: 查询为data之集合
    Map queryData(String api, YDParam param);

    // 并发查询
    Future queryDataByConcurrence(String api, YDParam param);

    // 函数并发
    void queryDataByConcurrence(String api, YDParam param, QueryLambda lambda);

    // 其它操作: 查询实例, 新增为实例Id, 删除/更新为空, ...
    Object operateData(String api, YDParam param);

    // 并发操作
    Future operateDataByConcurrence(String api, YDParam param);

    // 函数并发
    void operateDataByConcurrence(String api, YDParam param, OperateLambda lambda);
}