package com.malk.service.dingtalk;

import java.util.List;
import java.util.Map;

/**
 * 考勤
 *
 * @apiNote https://open.dingtalk.com/document/orgapp/attendance-overview
 */
public interface DDClient_Attendance {

    /**
     * 获取打卡结果
     *
     * @param query - access_token 请求凭证
     * @param body  - userIds      企业内的员工ID列表，最大值50;
     *              - 和workDateTo参数相隔最多7天（包含7天）; 格式为“yyyy-MM-dd HH:mm:ss”，HH:mm:ss可以使用00:00:00，将返回此日期从0点到24点的结果
     *              - offset 表示获取考勤数据的起始点, 下次获取传的offset值为之前的offset+limit
     *              - isI18n 是否为海外企业使用: true：海外平台使用, false（默认）：国内平台使用
     * @apiNote https://open.dingtalk.com/document/orgapp/open-attendance-clock-in-data
     */
    List<Map> listAttendanceResult(Map query, Map body);

    /**
     * 获取打卡详情
     *
     * @param query - access_token 请求凭证
     * @param body  - 企业内的员工ID列表，最大值50;
     *              - checkDateFrom 和workDateTo参数相隔最多7天（包含7天）; 注: 参数传"2021-12-01 18:00:00"，员工在19:00的打卡信息获取不到
     *              - isI18n 是否为海外企业使用: true：海外平台使用, false（默认）：国内平台使用
     * @apiNote https://open.dingtalk.com/document/orgapp/attendance-clock-in-record-is-open
     */
    List<Map> listAttendanceRecord(Map query, Map body);
}
