package com.malk.service.dingtalk;

import java.util.List;
import java.util.Map;

/**
 * 钉钉通讯录管理
 *
 * @apiNote https://open.dingtalk.com/document/orgapp/contacts-overview
 */
public interface DDClient_Contacts {

    /**
     * 获取子部门ID列表 [获取企业部门下的所有直属子部门列表]
     *
     * @param query - access_token 请求凭证
     * @param body  - dept_id 父部门ID，根部门传1
     * @apiNote https://open.dingtalk.com/document/orgapp/obtain-a-sub-department-id-list-v2
     */
    List<Number> listSubDepartmentId(Map query, Map body);

    /**
     * 获取部门用户userid列表 [无需分页]
     *
     * @param query - access_token 请求凭证
     * @param body  - dept_id 父部门ID，根部门传1
     * @apiNote https://open.dingtalk.com/document/orgapp/query-the-list-of-department-userids
     */
    List<String> listDepartmentUserId(Map query, Map body);

}
