package com.malk.service.dingtalk;

import com.malk.server.dingtalk.DDR_New;

import java.util.List;
import java.util.Map;

public interface DDClient_New {

    /**
     * token授权参数: 新版本
     */
    Map initTokenHeader();

    /**
     * 创建钉钉待办任务新版SDK
     *
     * @param createUserId       包含 unionId 与 operatorId 参数, 通过 userId 换取对应的 unionId 值
     * @param subject            待办标题，最大长度1024
     * @param description        待办备注描述，最大长度4096 [不显示]
     * @param dueTime            截止时间，Unix时间戳，单位毫秒
     * @param executorIds        执行者的unionId，最大数量1000
     * @param participantIds     参与者的unionId，最大数量1000
     * @param detailUrl          详情页url跳转地址: appUrl APP端详情页url跳转地址, pcUrl PC端详情页url跳转地址
     * @param isOnlyShowExecutor 生成的待办是否仅展示在执行者的待办列表中
     * @param priority           优先级，取值：10：较低, 20：普通, 30：紧急,40：非常紧急
     * @param notifyConfigs      待办通知配置: dingNotify DING通知配置，目前仅支持取值为1，表示应用内DING
     */
    DDR_New createTBTask(String createUserId, String subject, String description, long dueTime, List<String> executorIds, List<String> participantIds, Map detailUrl, boolean isOnlyShowExecutor, int priority, Map notifyConfigs);

    /**
     * 创建自由任务新版SDK https://open.dingtalk.com/document/orgapp-server/create-a-free-task
     */
}
