package com.malk.service.dingtalk.impl;

import com.malk.Util.UtilHttp;
import com.malk.server.dingtalk.DDR;
import com.malk.service.dingtalk.DDClient_Attendance;
import com.malk.service.dingtalk.DDClient_Contacts;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class DDClientImpl_Attendance implements DDClient_Contacts, DDClient_Attendance {

    /// 钉钉通用post请求
    private DDR dd_post_request(String url, Map header, Map param, Map body) {
        DDR rsp = (DDR) UtilHttp.doPost(url, header, param, body, DDR.class);
        return rsp;
    }

    /// 钉钉通用get请求
    private DDR dd_get_request(String url, Map header, Map param, Map body) {
        DDR rsp = (DDR) UtilHttp.doPost(url, header, param, body, DDR.class);
        return rsp;
    }


    //////////////////////////////////////////////////// 钉钉通讯录管理 ///////////////////////////////////////////////////

    /**
     * 获取子部门ID列表 [获取企业部门下的所有直属子部门列表]
     */
    @Override
    public List<Number> listSubDepartmentId(Map query, Map body) {
        Map rsp = (Map) dd_post_request("https://oapi.dingtalk.com/topapi/v2/department/listsubid", null, query, body).getResult();
        return (List<Number>) rsp.get("dept_id_list");
    }

    /**
     * 获取部门用户userid列表 [无需分页]
     */
    @Override
    public List<String> listDepartmentUserId(Map query, Map body) {
        Map rsp = (Map) dd_post_request("https://oapi.dingtalk.com/attendance/list", null, query, body).getRecordresult();
        return (List<String>) rsp.get("userid_list");
    }


    //////////////////////////////////////////////////// 考勤 ///////////////////////////////////////////////////////////

    /**
     * 获取打卡结果
     */
    @Override
    public List<Map> listAttendanceResult(Map query, Map body) {
        return dd_post_request("https://oapi.dingtalk.com/attendance/list", null, query, body).getRecordresult();
    }

    /**
     * 获取打卡详情
     */
    @Override
    public List<Map> listAttendanceRecord(Map query, Map body) {
        return dd_post_request("https://oapi.dingtalk.com/attendance/list", null, query, body).getRecordresult();
    }
}
