package com.malk.service.diwork;

import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.Map;
import java.util.function.Consumer;

public interface YSClient {

    /**
     * 保留token作为入参, 失效触发查询
     */
    String getAccessToken();

    /**
     * * B2C订单查询
     */
    void queryTradeOrder(@NotNull(message = "token不能为空") String accessToken, int pageIndex, String updateStart, String updateEnd, QueryLambda lambda);

    /**
     * B2C订单查询交易编号\订单ids
     */
    List<Map> queryTradeOrderByCondition(String tradeCode, String ids);
    
    /**
     * * 店铺信息查询
     */
    void queryStoreArchives(@NotNull(message = "token不能为空") String accessToken, QueryLambda lambda);

    /**
     * 订单财审
     */
    void financialApprove(@NotNull(message = "token不能为空") String accessToken, String orderIds, String payTime, Consumer lambda);

    /**
     * 订单弃审
     */
    void abandonApprove(@NotNull(message = "token不能为空") String accessToken, String orderIds, String payTime, String reason, Consumer lambda);

    /**
     * 订单弃审[新]
     *
     * @param ids    需要弃审订单id，多张用“,”分隔
     * @param reason 弃审原因
     */
    void abandonApprove(String ids, String reason);

    /**
     * 查询商品物料档案
     */
    Map getProductDetail(String accessToken, String productId);

    /**
     * 获取店铺系数
     */
    Map<String, Float> getShopCoefficient();

    @FunctionalInterface
    interface QueryLambda {
        void dataList(List<Map> dataList, int totalCount);
    }
}