package com.malk.service.ekuaibao.impl;

import com.malk.Util.UtilHttp;
import com.malk.server.ekuaibao.EKBConf;
import com.malk.service.ekuaibao.EKBClient;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

@Slf4j
@Service
public class EKBClientImpl implements EKBClient {

    @Autowired
    private EKBConf ekbConf;


    /**
     * 获取地址前缀
     */
    private String platformUrl;

    public String getPlatformUrl() {
        if (StringUtils.isBlank(platformUrl)) {
            Map rsp = (Map) UtilHttp.doGet(ekbConf.getPlatformApi() + "/api/openapi/v2/location?corpId=" + ekbConf.getCorpId(), null, (Map) null, Map.class);
            platformUrl = String.valueOf(rsp.get("value"));
        }
        return platformUrl;
    }

    /**
     * 创建单据
     */
    @Override
    public Map createFormInstance(String accessToken, boolean isCommit, boolean isUpdate, Map form, Map params) {
        Map param = new HashMap();
        param.put("accessToken", accessToken);
        param.put("isCommit", isCommit);
        param.put("isUpdate", isUpdate);
        Map body = new HashMap();
        body.put("form", form);
        body.put("params", params);
        Map rsp = (Map) UtilHttp.doPost(getPlatformUrl() + "/api/openapi/v2.2/flow/data", null, param, body, Map.class);
        return rsp;
    }
}
