package com.malk.service.u8open;

import java.util.List;
import java.util.Map;

public interface U8Client {

    /**
     * 查询采购订单列表
     */
    List<Map> queryPurchaseOrderList(String dateBegin, String dateEnd);

    /**
     * 查询采购订单详情
     */
    Map queryPurchaseOrderDetail(String voucherCode);

    /**
     * 平台交易号: 单据操作传上游单据号即可 -> 幂等[创建u8单据, 同一个交易号保证 ERP 中的资源不会重复被创建]
     */
    String queryTradeId();

    /**
     * 审核/弃审一张采购订单: 无需审批人(只有审核通过的订单才能弃审)
     */
    void approvePurchaseOrder(String voucherCode, boolean isVerify);

    /**
     * 审核/弃审采购订单: 需审批人(审批前需要先获取审批人登录, 否则访问报授权失败)
     */
    void approvePurchaseOrderByPerson(String voucherCode, String personCode, boolean isAgree, String remark);

    /**
     * 用户登录授权 [注意: 同一个账号不能同时在u8和接口登录, 建议对外审批接口虚拟一个审批人, u8单据配置为单据审批人]
     */
    void login2Authorization(String tradeId, String userId, String password);
}
