package com.malk.test;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Profile;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 指定运行环境 [参考TestController]
 */
@Profile({"dev", "test"})
@Validated
@RestController
@Slf4j
@RequestMapping("/test/yd")
public class YDTestController {

    @Autowired
    private YDClient ydClient;

    @Autowired
    private YDService ydService;

    @PostMapping("/update")
    McR ydUpdate() {
        List<String> syncArr = Arrays.asList(
                "FORM-EX866CB16ULWH7V3XYYMLCHP2CTU17K7V7RXKE",
                "FORM-NO966791GKEWG10YZNHXO9EP66VW19TTF0OXK71",
                "FORM-3J866L81IWFWFCFUZVY7TXXONK2U1KRH84OXKA",
                "FORM-WY766581KMEWJN9D1GWS97BAB7LD29EOS9OXKM",
                "FORM-LK766AC11YFWYCXU0O0XX50O7PBX280OIBOXKN1",
                "FORM-WY766581HSEWZP2946MZZB6M7P3Y2Y1890OXKD1");
        for (String formUuid : syncArr) {
            YDParam ydParam = new YDParam();
            ydParam.setAppType("APP_GXUUGZJ1ZPPBIJKLE9BH");
            ydParam.setSystemToken("KH766OB1OEFU141VX82MPV04ZS6R1M0WS8QUKD4");
            ydParam.setFormUuid(formUuid);
            ydService.queryLimitData(YDConf.API_FORM_QUERY_DATA, ydParam, YDService.INVOKE_TYPE.SYNC_SINGLE, list -> {
                for (Object form : list) {
                    Map data = (Map) ((Map) form).get("formData");
                    YDParam param = ObjectUtil.clone(ydParam);
                    JSONObject update = new JSONObject();
                    update.put("textField_kxgvp9s2", String.valueOf(data.get("textField_kxgvp9s2")).replace("https://www.aliwork.com", "https://fegroup.aliwork.com"));
                    param.setUpdateFormDataJson(update.toJSONString());
                    param.setFormInstId(String.valueOf(((Map) form).get("formInstId")));
                    ydClient.operateDataByConcurrence(YDConf.API_FORM_UPDATE, param);
                }
            });
        }
        return McR.success();
    }

    Integer index = 0;

    @GetMapping("insert")
    McR dzInsert() {

        index++;

        YDParam ydParam = new YDParam();
        ydParam.setAppType("APP_BT0NLNNL1O1ZQD1JMJCQ");
        ydParam.setSystemToken("16A6629115S3L0K6C9E7Y91UV9A23HV4J008LJ8");
        ydParam.setFormUuid("FORM-LK766AC1L2Q34W8OBVVQ998IT10I26VNEK98L31");
        Map data = new HashMap();
        data.put("textField_qzpa61f", index);
        data.put("textField_algkcgh", 65.0314);
        data.put("textField_0aoq38c", 0.0146);
        data.put("textField_6doxlyu", 0.0042);
        ydParam.setFormDataJson(JSON.toJSONString(data));
        ydClient.operateData(YDConf.API_FORM_CREATE, ydParam);
        return McR.success();
    }
}
